import os
import subprocess
from http.server import BaseHTTPRequestHandler, HTTPServer
import urllib.parse
import mimetypes
import ssl

class MyHandler(BaseHTTPRequestHandler):
    def do_GET(self):
        print(self.path)

        parsed_url = urllib.parse.urlparse(self.path)

        #if parsed_url.path.endswith('.m4a'):
        # Extract file name from path

        #filename = urllib.parse.unquote(parsed_url.path[1:]).replace("full/", "").replace("preview/", "")
        #print("filename: " + filename)

        # Convert the file to .wav using ffmpeg and cut the first 60 seconds
        output_filename = parsed_url.path[1:] #'/dev/shm/' + str(len(self.path)) + "_" + filename.split('.')[0].split("/")[-1] + '.wav'
        print(output_filename)

        #time_mgr = '-t' if self.path.split("/")[1] == "preview" else '-ss'
        #subprocess.run(['ffmpeg', '-i', prefix+filename, time_mgr, '20', '-y', output_filename], check=True)

        # Open the converted file and read it
        with open(output_filename, 'rb') as f:
            content = f.read()

        # Send response headers
        self.send_response(200)
        #self.send_header('Content-type', 'audio/x-wav')
        mimetype, _ = mimetypes.guess_type(output_filename)
        self.send_header('Content-type', mimetype)
        self.send_header('Content-Length', len(content))
        self.send_header('Cross-Origin-Embedder-Policy', 'require-corp')
        self.send_header('Cross-Origin-Opener-Policy', 'same-origin')
        self.send_header('Access-Control-Allow-Origin', '*')
        self.send_header('Access-Control-Allow-Methods', '*')
        self.send_header('Access-Control-Allow-Headers', '*')
        self.end_headers()

        # Send the content
        self.wfile.write(content)

        #os.remove(output_filename)
        #else:
        #    self.send_error(404, 'File Not Found: %s' % self.path)

def run(server_class=HTTPServer, handler_class=MyHandler):

    server_address = ('', 10464)
    httpd = server_class(server_address, handler_class)
    httpd.socket = ssl.wrap_socket(httpd.socket, certfile="/dev/shm/cube.crt", keyfile="/dev/shm/cube.key", server_side=True)

    print('Starting httpd...')
    httpd.serve_forever()

if __name__ == '__main__':
    run()
